import React, { useState, useCallback, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { csv, arc, pie } from 'd3';

const csvUrl = 'https://gist.githubusercontent.com/marianamartins87/c6065772bb75bf07d06d9a4ba8c7ad76/raw/cssColorNames.csv';

const width = 960;
const height = 500;
const centerX = width / 2;
const centerY = height / 2;

const pieArc = arc()
	.innerRadius(0)
	.outerRadius(width)

const App = () => {
  const [data, setData] = useState(null);
  
  useEffect(() => {
    csv(csvUrl).then(setData);
  }, []);
  
  if(!data) {
    return <pre>Loading...</pre>;
  }

  const colorPie = pie().value(1)
  
  return (
    <svg width={width} height={height}>
      <g transform={`translate(${centerX},${centerY})`}>
    	 {colorPie(data).map(d => (
    	   <path 
           fill={d.data['RGB hex value']} 
           d={pieArc(d)}
           />
        ))}
      </g>
  </svg>
  );
};
const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);